/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.21 from the
 * contents of Scoreboard.xs. Do not edit this file, edit Scoreboard.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "Scoreboard.xs"
#define PERL_NO_GET_CONTEXT /* we want efficiency */
#include "mod_perl.h"
#include "modperl_xs_sv_convert.h"
#include "modperl_xs_typedefs.h"
#include "modperl_xs_util.h"

#include "scoreboard.h"

/* XXX: currently only for mp2 */
#define SB_TRACE_DO 0

#if SB_TRACE_DO && defined(MP_TRACE)
#define SB_TRACE modperl_trace
#else
#define SB_TRACE if (0) modperl_trace
#endif

/* scoreboard */
typedef struct {
    scoreboard *sb;
    apr_pool_t *pool;
    int server_limit;
    int thread_limit;
} modperl_scoreboard_t;

typedef struct {
    worker_score *record;
    int parent_idx;
    int worker_idx;
} modperl_worker_score_t;

/* XXX: notice that here we reference a struct living in a different
 * perl object ($image), so if that object is destroyed earlier we get
 * a segfault. a possible solution: inline modperl_scoreboard_t in
 * modperl_parent_score_t (can't create a dependency inside $image,
 * since there can be many objects referencing it, will require a
 * complicated real ref counting)
 */
typedef struct {
    process_score *record;
    int idx;
    modperl_scoreboard_t *image;
} modperl_parent_score_t;

typedef modperl_scoreboard_t   *Apache__Scoreboard;
typedef modperl_worker_score_t *Apache__ScoreboardWorkerScore;
typedef modperl_parent_score_t *Apache__ScoreboardParentScore;

static char status_flags[SERVER_NUM_STATUS];

#define server_limit(image) image->server_limit
#define thread_limit(image) image->thread_limit
    
#define scoreboard_up_time(image)                               \
    (apr_uint32_t) apr_time_sec(                                \
        apr_time_now() - image->sb->global->restart_time);

#define parent_score_pid(mps)  mps->record->pid

#define worker_score_most_recent(mws)                                   \
    (apr_uint32_t) apr_time_sec(apr_time_now() - mws->record->last_used);

/* XXX: as of 20031219, tid is not maintained in scoreboard */
#if APR_HAS_THREADS
#define worker_score_tid(mws)             mws->record->tid
#else
#define worker_score_tid(mws)             NULL
#endif

#define worker_score_thread_num(mws)      mws->record->thread_num
#define worker_score_access_count(mws)    mws->record->access_count
#define worker_score_bytes_served(mws)    mws->record->bytes_served
#define worker_score_my_access_count(mws) mws->record->my_access_count
#define worker_score_my_bytes_served(mws) mws->record->my_bytes_served
#define worker_score_conn_bytes(mws)      mws->record->conn_bytes
#define worker_score_conn_count(mws)      mws->record->conn_count
#define worker_score_client(mws)          mws->record->client
#define worker_score_request(mws)         mws->record->request
#define worker_score_vhost(mws)           mws->record->vhost

/* a worker that have served/serves at least one request and isn't
 * dead yet */
#define LIVE_WORKER(ws) !(ws->access_count == 0 && ws->status == SERVER_DEAD)

/* a worker that does something at this very moment */
#define ACTIVE_WORKER(ws)                                               \
    !(ws->access_count == 0 &&                                          \
      (ws->status == SERVER_DEAD || ws->status == SERVER_READY))

#include "apxs/send.c"

static void status_flags_init(void)
{
    status_flags[SERVER_DEAD]           = '.';
    status_flags[SERVER_READY]          = '_';
    status_flags[SERVER_STARTING]       = 'S';
    status_flags[SERVER_BUSY_READ]      = 'R';
    status_flags[SERVER_BUSY_WRITE]     = 'W';
    status_flags[SERVER_BUSY_KEEPALIVE] = 'K';
    status_flags[SERVER_BUSY_LOG]       = 'L';
    status_flags[SERVER_BUSY_DNS]       = 'D';
    status_flags[SERVER_CLOSING]        = 'C';
    status_flags[SERVER_GRACEFUL]       = 'G';
    status_flags[SERVER_IDLE_KILL]      = 'I';
}

static void constants_init(pTHX)
{
      HV *stash;
      int server_limit, thread_limit;

      /* SERVER_LIMIT and THREAD_LIMIT constants are deprecated, use
       * $image->server_limit and $image->thread_limit instead */
#ifndef DUMMY_SCOREBOARD
    ap_mpm_query(AP_MPMQ_HARD_LIMIT_DAEMONS, &server_limit);
    ap_mpm_query(AP_MPMQ_HARD_LIMIT_THREADS, &thread_limit);
#else
    /* XXX: how can we figure out that data w/o having an access to
     * ap_mpm_query? */
    server_limit = 0;
    thread_limit = 0;
#endif
    
    stash = gv_stashpv("Apache::Const", TRUE);
    newCONSTSUB(stash, "SERVER_LIMIT", newSViv(server_limit));
    
    stash = gv_stashpv("Apache::Const", TRUE);
    newCONSTSUB(stash, "THREAD_LIMIT", newSViv(thread_limit));

    stash = gv_stashpv("Apache::Scoreboard", TRUE);
    newCONSTSUB(stash, "REMOTE_SCOREBOARD_TYPE",
                newSVpv(REMOTE_SCOREBOARD_TYPE, 0));

}

MP_INLINE
static worker_score *my_get_scoreboard_worker(pTHX_
                                              modperl_scoreboard_t *image,
                                              int x, int y)
{
    if (((x < 0) || (image->server_limit < x)) ||
        ((y < 0) || (image->thread_limit < y))) {
        Perl_croak(aTHX_ "worker score [%d][%d] is out of limit", x, y);
    }
    return &image->sb->servers[x][y];
}

MP_INLINE
static process_score *my_get_scoreboard_process(pTHX_
                                                modperl_scoreboard_t *image,
                                                int x)
{
    if ((x < 0) || (image->server_limit < x)) {
        Perl_croak(aTHX_ "parent score [%d] is out of limit", x);
    }
    return &image->sb->parent[x];
}

static void image_sanity_check(pTHX)
{
#ifdef DUMMY_SCOREBOARD
    Perl_croak(aTHX_ "Don't call the image() method when not"
               "running under mod_perl");
#endif
}

#ifdef DUMMY_SCOREBOARD
#define MY_WARN fprintf(stderr,
#else
#define MY_WARN ap_log_error(APLOG_MARK, APLOG_ERR, 0, modperl_global_get_server_rec(),
#endif
      
#if 0
static void debug_dump_sb(modperl_scoreboard_t *image)
{
    int i, j;

    for (i = 0; i < image->server_limit; i++) {
        for (j = 0; j < image->thread_limit; j++) {
            worker_score *ws = &image->sb->servers[i][j];
            if (ws->access_count) {
                MY_WARN
                    "rcv %02d-%02d: stat: %c cnt: %d\n", i, j,
                    status_flags[ws->status],
                    (int)ws->access_count);
            }
        }
    }
}
#endif







#line 208 "Scoreboard.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
            Perl_croak(aTHX_ "Usage: %s::%s(%s)", hvname, gvname, params);
        else
            Perl_croak(aTHX_ "Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
        Perl_croak(aTHX_ "Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#ifdef PERL_IMPLICIT_CONTEXT
#define croak_xs_usage(a,b)	S_croak_xs_usage(aTHX_ a,b)
#else
#define croak_xs_usage		S_croak_xs_usage
#endif

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#line 260 "Scoreboard.c"

XS(XS_Apache__Scoreboard_send); /* prototype to pass -Wmissing-prototypes */
XS(XS_Apache__Scoreboard_send)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "r");
    {
	Apache2__RequestRec	r = modperl_xs_sv2request_rec(aTHX_ ST(0), "Apache2::RequestRec", cv);
	int	RETVAL;
	dXSTARG;

	RETVAL = scoreboard_send(r);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Apache__Scoreboard_freeze); /* prototype to pass -Wmissing-prototypes */
XS(XS_Apache__Scoreboard_freeze)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "image");
    {
	Apache__Scoreboard	image;
#line 222 "Scoreboard.xs"
    int psize, ssize, tsize, msize, i;
    char buf[SIZE16*4];
    char *dptr, *ptr = buf;
    scoreboard *sb;

#line 302 "Scoreboard.c"
	SV *	RETVAL;

	if (sv_derived_from(ST(0), "Apache::Scoreboard")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    image = INT2PTR(Apache__Scoreboard,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Apache::Scoreboard::freeze",
			"image", "Apache::Scoreboard");
#line 228 "Scoreboard.xs"
    sb = image->sb;

    psize = sizeof(process_score) * image->server_limit;
    msize = sizeof(worker_score)  * image->thread_limit;
    ssize = msize * image->server_limit;
    tsize = psize + ssize + sizeof(global_score) + sizeof(buf);
    /* fprintf(stderr, "sizes %d, %d, %d, %d, %d\n",
       psize, ssize, sizeof(global_score) , sizeof(buf), tsize); */

    pack16(ptr, psize);
    ptr += SIZE16;
    pack16(ptr, ssize);
    ptr += SIZE16;
    pack16(ptr, image->server_limit);
    ptr += SIZE16;
    pack16(ptr, image->thread_limit);

    RETVAL = NEWSV(0, tsize);
    dptr = SvPVX(RETVAL);
    SvCUR_set(RETVAL, tsize+1);
    SvPOK_only(RETVAL);

    /* fill the data buffer with the data we want to freeze */
    Move(&buf[0],        dptr, sizeof(buf),          char);
    dptr += sizeof(buf);
    Move(&sb->parent[0], dptr, psize,                char);
    dptr += psize;
    for (i = 0; i < image->server_limit; i++) {
        Move(sb->servers[i], dptr, msize, char);
        dptr += msize;
    }
    Move(&sb->global,    dptr, sizeof(global_score), char);

#line 347 "Scoreboard.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Apache__Scoreboard_thaw); /* prototype to pass -Wmissing-prototypes */
XS(XS_Apache__Scoreboard_thaw)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "CLASS, pool, packet");
    {
	SV *	CLASS = ST(0);
	APR__Pool	pool;
	SV *	packet = ST(2);
#line 271 "Scoreboard.xs"
    modperl_scoreboard_t *image;
    scoreboard *sb;
    int psize, ssize;
    char *ptr;
    int i;

#line 376 "Scoreboard.c"
	Apache__Scoreboard	RETVAL;

	if (sv_derived_from(ST(1), "APR::Pool")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    pool = INT2PTR(APR__Pool,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Apache::Scoreboard::thaw",
			"pool", "APR::Pool");
#line 278 "Scoreboard.xs"
    if (!(SvOK(packet) && SvCUR(packet) > (SIZE16*2))) {
        XSRETURN_UNDEF;
    }

    CLASS = CLASS; /* avoid warnings */

    image = (modperl_scoreboard_t *)apr_pcalloc(pool, sizeof(*image));

    ptr = SvPVX(packet);
    psize = unpack16(ptr);
    ptr += SIZE16;
    ssize = unpack16(ptr);
    ptr += SIZE16;
    image->server_limit = unpack16(ptr);
    ptr += SIZE16;
    image->thread_limit = unpack16(ptr);
    ptr += SIZE16;

   /* MY_WARN
      "recv: sizes server_num=%d, thread_num=%d, psize=%d, "
                 "ssize=%d\n",
                 image->server_limit, image->thread_limit, psize, ssize);
   */

    sb = (scoreboard *)apr_palloc(pool, sizeof(scoreboard) +
                                   image->server_limit * sizeof(worker_score *));
    sb->parent  = (process_score *)Copy_pool(pool, ptr, psize, char);
    ptr += psize;

    sb->servers = (worker_score **)((char*)sb + sizeof(scoreboard));
    for (i = 0; i < image->server_limit; i++) {
        sb->servers[i] = (worker_score *)Copy_pool(pool, ptr,
                                                   image->thread_limit * sizeof(worker_score), char);
        ptr += image->thread_limit * sizeof(worker_score);
    }

    sb->global  = (global_score *)Copy_pool(pool, ptr,
                                            sizeof(global_score), char);

    image->pool = pool;
    image->sb   = sb;

   /* debug_dump_sb(image); */

    RETVAL = image;

#line 434 "Scoreboard.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Apache::Scoreboard", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Apache__Scoreboard_image); /* prototype to pass -Wmissing-prototypes */
XS(XS_Apache__Scoreboard_image)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "CLASS, pool_sv");
    {
	SV *	CLASS = ST(0);
	SV *	pool_sv = ST(1);
	SV *	RETVAL;
#line 334 "Scoreboard.xs"
    modperl_scoreboard_t *image;
    apr_pool_t *pool = mp_xs_sv2_APR__Pool(pool_sv);

#line 460 "Scoreboard.c"
#line 338 "Scoreboard.xs"
    image_sanity_check(aTHX);

    image = (modperl_scoreboard_t *)apr_palloc(pool, sizeof(*image));

    if (ap_exists_scoreboard_image()) {
        image->sb   = ap_scoreboard_image;
        image->pool = pool;
        ap_mpm_query(AP_MPMQ_HARD_LIMIT_DAEMONS, &(image->server_limit));
        ap_mpm_query(AP_MPMQ_HARD_LIMIT_THREADS, &(image->thread_limit));
    }
    else {
        Perl_croak(aTHX_ "ap_scoreboard_image doesn't exist");
    }
    RETVAL = sv_setref_pv(NEWSV(0, 0), "Apache::Scoreboard", (void*)image);
    /* make sure the pool sticks around as long as this object is alive */
    mpxs_add_pool_magic(RETVAL, pool_sv);

    CLASS = CLASS; /* avoid warnings */

#line 481 "Scoreboard.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Apache__Scoreboard_server_limit); /* prototype to pass -Wmissing-prototypes */
XS(XS_Apache__Scoreboard_server_limit)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "image");
    {
	Apache__Scoreboard	image;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Apache::Scoreboard")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    image = INT2PTR(Apache__Scoreboard,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Apache::Scoreboard::server_limit",
			"image", "Apache::Scoreboard");

	RETVAL = server_limit(image);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Apache__Scoreboard_thread_limit); /* prototype to pass -Wmissing-prototypes */
XS(XS_Apache__Scoreboard_thread_limit)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "image");
    {
	Apache__Scoreboard	image;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Apache::Scoreboard")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    image = INT2PTR(Apache__Scoreboard,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Apache::Scoreboard::thread_limit",
			"image", "Apache::Scoreboard");

	RETVAL = thread_limit(image);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Apache__Scoreboard_parent_score); /* prototype to pass -Wmissing-prototypes */
XS(XS_Apache__Scoreboard_parent_score)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "image, idx=0");
    {
	Apache__Scoreboard	image;
	int	idx;
#line 376 "Scoreboard.xs"
    process_score *ps;

#line 567 "Scoreboard.c"
	Apache__ScoreboardParentScore	RETVAL;

	if (sv_derived_from(ST(0), "Apache::Scoreboard")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    image = INT2PTR(Apache__Scoreboard,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Apache::Scoreboard::parent_score",
			"image", "Apache::Scoreboard");

	if (items < 2)
	    idx = 0;
	else {
	    idx = (int)SvIV(ST(1));
	}
#line 379 "Scoreboard.xs"
    ps = my_get_scoreboard_process(aTHX_ image, idx);
    /* XXX */
    if (!ps->quiescing && ps->pid) {
        RETVAL = (modperl_parent_score_t *)apr_pcalloc(image->pool,
                                                       (sizeof(*RETVAL)));
        RETVAL->record = ps;
        RETVAL->idx    = idx;
        RETVAL->image  = image;
    }
    else {
        XSRETURN_UNDEF;
    }

#line 598 "Scoreboard.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Apache::ScoreboardParentScore", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Apache__Scoreboard_worker_score); /* prototype to pass -Wmissing-prototypes */
XS(XS_Apache__Scoreboard_worker_score)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "image, parent_idx, worker_idx");
    {
	Apache__Scoreboard	image;
	int	parent_idx = (int)SvIV(ST(1));
	int	worker_idx = (int)SvIV(ST(2));
#line 402 "Scoreboard.xs"
    worker_score *ws;

#line 623 "Scoreboard.c"
	Apache__ScoreboardWorkerScore	RETVAL;

	if (sv_derived_from(ST(0), "Apache::Scoreboard")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    image = INT2PTR(Apache__Scoreboard,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Apache::Scoreboard::worker_score",
			"image", "Apache::Scoreboard");
#line 405 "Scoreboard.xs"
    ws = my_get_scoreboard_worker(aTHX_ image, parent_idx, worker_idx);
    RETVAL = (modperl_worker_score_t *)apr_pcalloc(image->pool,
                                                   (sizeof(*RETVAL)));
    RETVAL->parent_idx = parent_idx;
    RETVAL->worker_idx = worker_idx;
    RETVAL->record = ws;

#line 642 "Scoreboard.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Apache::ScoreboardWorkerScore", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Apache__Scoreboard_pids); /* prototype to pass -Wmissing-prototypes */
XS(XS_Apache__Scoreboard_pids)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "image");
    {
	Apache__Scoreboard	image;
#line 420 "Scoreboard.xs"
    AV *av = newAV();
    int i;
    scoreboard *sb;

#line 667 "Scoreboard.c"
	SV *	RETVAL;

	if (sv_derived_from(ST(0), "Apache::Scoreboard")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    image = INT2PTR(Apache__Scoreboard,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Apache::Scoreboard::pids",
			"image", "Apache::Scoreboard");
#line 425 "Scoreboard.xs"
    sb = image->sb;
    for (i = 0; i < image->server_limit; i++) {
        if (!(sb->parent[i].pid)) {
            break;
        }
        /* fprintf(stderr, "pids: server %d: pid %d\n",
           i, (int)(sb->parent[i].pid)); */
        av_push(av, newSViv(sb->parent[i].pid));
    }

    RETVAL = newRV_noinc((SV*)av);

#line 691 "Scoreboard.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Apache__Scoreboard_parent_idx_by_pid); /* prototype to pass -Wmissing-prototypes */
XS(XS_Apache__Scoreboard_parent_idx_by_pid)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "image, pid");
    {
	Apache__Scoreboard	image;
	pid_t	pid = (pid_t)SvIV(ST(1));
#line 449 "Scoreboard.xs"
    int i;
    scoreboard *sb;

#line 716 "Scoreboard.c"
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Apache::Scoreboard")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    image = INT2PTR(Apache__Scoreboard,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Apache::Scoreboard::parent_idx_by_pid",
			"image", "Apache::Scoreboard");
#line 453 "Scoreboard.xs"
    sb = image->sb;
    RETVAL = -1;

    for (i = 0; i < image->server_limit; i++) {
        if (sb->parent[i].pid == pid) {
            RETVAL = i;
            break;
        }
    }

#line 739 "Scoreboard.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Apache__Scoreboard_thread_numbers); /* prototype to pass -Wmissing-prototypes */
XS(XS_Apache__Scoreboard_thread_numbers)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "image, parent_idx");
    {
	Apache__Scoreboard	image;
	int	parent_idx = (int)SvIV(ST(1));
#line 472 "Scoreboard.xs"
    AV *av = newAV();
    int i;
    scoreboard *sb;

#line 764 "Scoreboard.c"
	SV *	RETVAL;

	if (sv_derived_from(ST(0), "Apache::Scoreboard")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    image = INT2PTR(Apache__Scoreboard,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Apache::Scoreboard::thread_numbers",
			"image", "Apache::Scoreboard");
#line 477 "Scoreboard.xs"
    sb = image->sb;

    for (i = 0; i < image->thread_limit; ++i) {
        /* fprintf(stderr, "thread_num: server %d, thread %d pid %d\n",
           i, sb->servers[parent_idx][i].thread_num,
           (int)(sb->parent[parent_idx].pid)); */

        av_push(av, newSViv(sb->servers[parent_idx][i].thread_num));
    }

    RETVAL = newRV_noinc((SV*)av);

#line 788 "Scoreboard.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Apache__Scoreboard_up_time); /* prototype to pass -Wmissing-prototypes */
XS(XS_Apache__Scoreboard_up_time)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "image");
    {
	Apache__Scoreboard	image;
	apr_uint32_t	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Apache::Scoreboard")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    image = INT2PTR(Apache__Scoreboard,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Apache::Scoreboard::up_time",
			"image", "Apache::Scoreboard");

	RETVAL = scoreboard_up_time(image);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Apache__ScoreboardParentScore_next); /* prototype to pass -Wmissing-prototypes */
XS(XS_Apache__ScoreboardParentScore_next)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Apache__ScoreboardParentScore	self;
#line 510 "Scoreboard.xs"
    int next_idx;
    process_score *ps;
    modperl_scoreboard_t *image;

#line 844 "Scoreboard.c"
	Apache__ScoreboardParentScore	RETVAL;

	if (sv_derived_from(ST(0), "Apache::ScoreboardParentScore")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Apache__ScoreboardParentScore,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Apache::ScoreboardParentScore::next",
			"self", "Apache::ScoreboardParentScore");
#line 515 "Scoreboard.xs"
    image = self->image;
    next_idx = self->idx + 1;
    if (next_idx <= image->server_limit) {
        ps = my_get_scoreboard_process(aTHX_ image, next_idx);
    }
    else {
        XSRETURN_UNDEF;
    }

    if (ps->pid) {
        RETVAL = (modperl_parent_score_t *)apr_pcalloc(image->pool,
                                                       sizeof(*RETVAL));
        RETVAL->record = ps;
        RETVAL->idx    = next_idx;
        RETVAL->image  = image;
    }
    else {
        XSRETURN_UNDEF;
    }

#line 876 "Scoreboard.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Apache::ScoreboardParentScore", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Apache__ScoreboardParentScore_worker_score); /* prototype to pass -Wmissing-prototypes */
XS(XS_Apache__ScoreboardParentScore_worker_score)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Apache__ScoreboardParentScore	self;
	Apache__ScoreboardWorkerScore	RETVAL;

	if (sv_derived_from(ST(0), "Apache::ScoreboardParentScore")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Apache__ScoreboardParentScore,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Apache::ScoreboardParentScore::worker_score",
			"self", "Apache::ScoreboardParentScore");
#line 543 "Scoreboard.xs"
    RETVAL = (modperl_worker_score_t *)apr_pcalloc(self->image->pool,
                                                   sizeof(*RETVAL));
    RETVAL->parent_idx = self->idx;
    RETVAL->worker_idx = 0;
    RETVAL->record     = my_get_scoreboard_worker(aTHX_ self->image,
                                                  self->idx, 0);

#line 914 "Scoreboard.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Apache::ScoreboardWorkerScore", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Apache__ScoreboardParentScore_next_worker_score); /* prototype to pass -Wmissing-prototypes */
XS(XS_Apache__ScoreboardParentScore_next_worker_score)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "self, mws");
    {
	Apache__ScoreboardParentScore	self;
	Apache__ScoreboardWorkerScore	mws;
#line 559 "Scoreboard.xs"
    int next_idx;

#line 938 "Scoreboard.c"
	Apache__ScoreboardWorkerScore	RETVAL;

	if (sv_derived_from(ST(0), "Apache::ScoreboardParentScore")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Apache__ScoreboardParentScore,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Apache::ScoreboardParentScore::next_worker_score",
			"self", "Apache::ScoreboardParentScore");

	if (sv_derived_from(ST(1), "Apache::ScoreboardWorkerScore")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    mws = INT2PTR(Apache__ScoreboardWorkerScore,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Apache::ScoreboardParentScore::next_worker_score",
			"mws", "Apache::ScoreboardWorkerScore");
#line 562 "Scoreboard.xs"
    next_idx = mws->worker_idx + 1;
    if (next_idx < self->image->thread_limit) {
        RETVAL = (modperl_worker_score_t *)apr_pcalloc(self->image->pool,
                                                       sizeof(*RETVAL));
        RETVAL->parent_idx = mws->parent_idx;
        RETVAL->worker_idx = next_idx;
        RETVAL->record     = my_get_scoreboard_worker(aTHX_ self->image,
                                                      mws->parent_idx, next_idx);
    }
    else {
        XSRETURN_UNDEF;
    }

#line 972 "Scoreboard.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Apache::ScoreboardWorkerScore", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Apache__ScoreboardParentScore_next_live_worker_score); /* prototype to pass -Wmissing-prototypes */
XS(XS_Apache__ScoreboardParentScore_next_live_worker_score)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "self, mws");
    {
	Apache__ScoreboardParentScore	self;
	Apache__ScoreboardWorkerScore	mws;
#line 585 "Scoreboard.xs"
    int next_idx;
    int found = 0;

#line 997 "Scoreboard.c"
	Apache__ScoreboardWorkerScore	RETVAL;

	if (sv_derived_from(ST(0), "Apache::ScoreboardParentScore")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Apache__ScoreboardParentScore,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Apache::ScoreboardParentScore::next_live_worker_score",
			"self", "Apache::ScoreboardParentScore");

	if (sv_derived_from(ST(1), "Apache::ScoreboardWorkerScore")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    mws = INT2PTR(Apache__ScoreboardWorkerScore,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Apache::ScoreboardParentScore::next_live_worker_score",
			"mws", "Apache::ScoreboardWorkerScore");
#line 589 "Scoreboard.xs"
    next_idx = mws->worker_idx;

    while (++next_idx < self->image->thread_limit) {
        worker_score *ws = my_get_scoreboard_worker(aTHX_ self->image,
                                                    mws->parent_idx, next_idx);
        if (LIVE_WORKER(ws)) {
            RETVAL = (modperl_worker_score_t *)apr_pcalloc(self->image->pool,
                                                           sizeof(*RETVAL));
            RETVAL->record     = ws;
            RETVAL->parent_idx = mws->parent_idx;
            RETVAL->worker_idx = next_idx;
            found++;
            break;
        }
    }

    if (!found) {
        XSRETURN_UNDEF;
    }

#line 1038 "Scoreboard.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Apache::ScoreboardWorkerScore", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Apache__ScoreboardParentScore_next_active_worker_score); /* prototype to pass -Wmissing-prototypes */
XS(XS_Apache__ScoreboardParentScore_next_active_worker_score)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "self, mws");
    {
	Apache__ScoreboardParentScore	self;
	Apache__ScoreboardWorkerScore	mws;
#line 620 "Scoreboard.xs"
    int next_idx;
    int found = 0;

#line 1063 "Scoreboard.c"
	Apache__ScoreboardWorkerScore	RETVAL;

	if (sv_derived_from(ST(0), "Apache::ScoreboardParentScore")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Apache__ScoreboardParentScore,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Apache::ScoreboardParentScore::next_active_worker_score",
			"self", "Apache::ScoreboardParentScore");

	if (sv_derived_from(ST(1), "Apache::ScoreboardWorkerScore")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    mws = INT2PTR(Apache__ScoreboardWorkerScore,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Apache::ScoreboardParentScore::next_active_worker_score",
			"mws", "Apache::ScoreboardWorkerScore");
#line 624 "Scoreboard.xs"
    next_idx = mws->worker_idx;
    while (++next_idx < self->image->thread_limit) {
        worker_score *ws = my_get_scoreboard_worker(aTHX_ self->image,
                                                    mws->parent_idx, next_idx);
        if (ACTIVE_WORKER(ws)) {
            RETVAL = (modperl_worker_score_t *)apr_pcalloc(self->image->pool,
                                                           sizeof(*RETVAL));
            RETVAL->record     = ws;
            RETVAL->parent_idx = mws->parent_idx;
            RETVAL->worker_idx = next_idx;
            found++;
            break;
        }
    }

    if (!found) {
        XSRETURN_UNDEF;
    }

#line 1103 "Scoreboard.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Apache::ScoreboardWorkerScore", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Apache__ScoreboardParentScore_pid); /* prototype to pass -Wmissing-prototypes */
XS(XS_Apache__ScoreboardParentScore_pid)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Apache__ScoreboardParentScore	self;
	pid_t	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Apache::ScoreboardParentScore")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Apache__ScoreboardParentScore,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Apache::ScoreboardParentScore::pid",
			"self", "Apache::ScoreboardParentScore");

	RETVAL = parent_score_pid(self);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Apache__ScoreboardWorkerScore_times); /* prototype to pass -Wmissing-prototypes */
XS(XS_Apache__ScoreboardWorkerScore_times)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "self");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Apache__ScoreboardWorkerScore	self;

	if (sv_derived_from(ST(0), "Apache::ScoreboardWorkerScore")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Apache__ScoreboardWorkerScore,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Apache::ScoreboardWorkerScore::times",
			"self", "Apache::ScoreboardWorkerScore");
#line 665 "Scoreboard.xs"
    if (GIMME == G_ARRAY) {
        /* same return values as CORE::times() */
        EXTEND(sp, 4);
        PUSHs(sv_2mortal(newSViv(self->record->times.tms_utime)));
        PUSHs(sv_2mortal(newSViv(self->record->times.tms_stime)));
        PUSHs(sv_2mortal(newSViv(self->record->times.tms_cutime)));
        PUSHs(sv_2mortal(newSViv(self->record->times.tms_cstime)));
    }
    else {
#ifdef _SC_CLK_TCK
        float tick = sysconf(_SC_CLK_TCK);
#else
        float tick = HZ;
#endif
        if (self->record->access_count) {
            /* cpu %, same value mod_status displays */
            float RETVAL = (self->record->times.tms_utime +
                            self->record->times.tms_stime +
                            self->record->times.tms_cutime +
                            self->record->times.tms_cstime);
            XPUSHs(sv_2mortal(newSVnv((double)RETVAL/tick)));
        }
        else {
            XPUSHs(sv_2mortal(newSViv((0))));
        }
    }
#line 1192 "Scoreboard.c"
	PUTBACK;
	return;
    }
}


XS(XS_Apache__ScoreboardWorkerScore_start_time); /* prototype to pass -Wmissing-prototypes */
XS(XS_Apache__ScoreboardWorkerScore_start_time)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Apache__ScoreboardWorkerScore	self;
#line 701 "Scoreboard.xs"
    apr_time_t tp;

#line 1217 "Scoreboard.c"

	if (sv_derived_from(ST(0), "Apache::ScoreboardWorkerScore")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Apache__ScoreboardWorkerScore,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			GvNAME(CvGV(cv)),
			"self", "Apache::ScoreboardWorkerScore");
#line 704 "Scoreboard.xs"
    ix = ix; /* warnings */
    tp = (XSANY.any_i32 == 0) ? 
         self->record->start_time : self->record->stop_time;

    SB_TRACE(MP_FUNC, "%s_time: %5" APR_TIME_T_FMT "\n",
            (XSANY.any_i32 == 0 ? "start" : "stop"), tp);

    {
        SB_TRACE(MP_FUNC, "start: %5" APR_TIME_T_FMT "\n"
                 "stop: %5" APR_TIME_T_FMT "\n"
                 "last used: %5" APR_TIME_T_FMT "\n",
                 self->record->start_time,
                 self->record->stop_time,
                 self->record->last_used);
    }

    /* do the same as Time::HiRes::gettimeofday */
    if (GIMME == G_ARRAY) {
        EXTEND(sp, 2);
        PUSHs(sv_2mortal(newSViv(apr_time_sec(tp))));
        PUSHs(sv_2mortal(newSViv(apr_time_usec(tp))));
    } 
    else {
        EXTEND(sp, 1);
        PUSHs(sv_2mortal(newSVnv(apr_time_sec(tp))));
    }
#line 1254 "Scoreboard.c"
	PUTBACK;
	return;
    }
}


XS(XS_Apache__ScoreboardWorkerScore_req_time); /* prototype to pass -Wmissing-prototypes */
XS(XS_Apache__ScoreboardWorkerScore_req_time)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Apache__ScoreboardWorkerScore	self;
	long	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Apache::ScoreboardWorkerScore")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Apache__ScoreboardWorkerScore,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Apache::ScoreboardWorkerScore::req_time",
			"self", "Apache::ScoreboardWorkerScore");
#line 736 "Scoreboard.xs"
    if (self->record->start_time == 0L) {
        RETVAL = 0L;
    }
    else {
        RETVAL = (long)
            ((self->record->stop_time - self->record->start_time) / 1000);
    }
    if (RETVAL < 0L || !self->record->access_count) {
        RETVAL = 0L;
    }

#line 1296 "Scoreboard.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Apache__ScoreboardWorkerScore_status); /* prototype to pass -Wmissing-prototypes */
XS(XS_Apache__ScoreboardWorkerScore_status)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Apache__ScoreboardWorkerScore	self;
	SV *	RETVAL;

	if (sv_derived_from(ST(0), "Apache::ScoreboardWorkerScore")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Apache__ScoreboardWorkerScore,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Apache::ScoreboardWorkerScore::status",
			"self", "Apache::ScoreboardWorkerScore");
#line 755 "Scoreboard.xs"
    RETVAL = newSV(0);
    sv_setnv(RETVAL, (double)self->record->status);
    Perl_sv_setpvf(aTHX_ RETVAL, "%c", status_flags[self->record->status]);
    SvNOK_on(RETVAL); /* dual-var */ 

#line 1331 "Scoreboard.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Apache__ScoreboardWorkerScore_tid); /* prototype to pass -Wmissing-prototypes */
XS(XS_Apache__ScoreboardWorkerScore_tid)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Apache__ScoreboardWorkerScore	self;
	U32	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Apache::ScoreboardWorkerScore")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Apache__ScoreboardWorkerScore,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Apache::ScoreboardWorkerScore::tid",
			"self", "Apache::ScoreboardWorkerScore");
#line 769 "Scoreboard.xs"
    RETVAL = worker_score_tid(self);

#line 1365 "Scoreboard.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Apache__ScoreboardWorkerScore_thread_num); /* prototype to pass -Wmissing-prototypes */
XS(XS_Apache__ScoreboardWorkerScore_thread_num)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Apache__ScoreboardWorkerScore	self;
	int	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Apache::ScoreboardWorkerScore")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Apache__ScoreboardWorkerScore,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Apache::ScoreboardWorkerScore::thread_num",
			"self", "Apache::ScoreboardWorkerScore");

	RETVAL = worker_score_thread_num(self);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Apache__ScoreboardWorkerScore_access_count); /* prototype to pass -Wmissing-prototypes */
XS(XS_Apache__ScoreboardWorkerScore_access_count)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Apache__ScoreboardWorkerScore	self;
	unsigned long	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Apache::ScoreboardWorkerScore")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Apache__ScoreboardWorkerScore,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Apache::ScoreboardWorkerScore::access_count",
			"self", "Apache::ScoreboardWorkerScore");

	RETVAL = worker_score_access_count(self);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Apache__ScoreboardWorkerScore_bytes_served); /* prototype to pass -Wmissing-prototypes */
XS(XS_Apache__ScoreboardWorkerScore_bytes_served)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Apache__ScoreboardWorkerScore	self;
	unsigned long	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Apache::ScoreboardWorkerScore")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Apache__ScoreboardWorkerScore,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Apache::ScoreboardWorkerScore::bytes_served",
			"self", "Apache::ScoreboardWorkerScore");

	RETVAL = worker_score_bytes_served(self);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Apache__ScoreboardWorkerScore_my_access_count); /* prototype to pass -Wmissing-prototypes */
XS(XS_Apache__ScoreboardWorkerScore_my_access_count)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Apache__ScoreboardWorkerScore	self;
	unsigned long	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Apache::ScoreboardWorkerScore")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Apache__ScoreboardWorkerScore,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Apache::ScoreboardWorkerScore::my_access_count",
			"self", "Apache::ScoreboardWorkerScore");

	RETVAL = worker_score_my_access_count(self);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Apache__ScoreboardWorkerScore_my_bytes_served); /* prototype to pass -Wmissing-prototypes */
XS(XS_Apache__ScoreboardWorkerScore_my_bytes_served)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Apache__ScoreboardWorkerScore	self;
	unsigned long	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Apache::ScoreboardWorkerScore")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Apache__ScoreboardWorkerScore,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Apache::ScoreboardWorkerScore::my_bytes_served",
			"self", "Apache::ScoreboardWorkerScore");

	RETVAL = worker_score_my_bytes_served(self);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Apache__ScoreboardWorkerScore_conn_bytes); /* prototype to pass -Wmissing-prototypes */
XS(XS_Apache__ScoreboardWorkerScore_conn_bytes)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Apache__ScoreboardWorkerScore	self;
	unsigned long	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Apache::ScoreboardWorkerScore")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Apache__ScoreboardWorkerScore,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Apache::ScoreboardWorkerScore::conn_bytes",
			"self", "Apache::ScoreboardWorkerScore");

	RETVAL = worker_score_conn_bytes(self);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Apache__ScoreboardWorkerScore_conn_count); /* prototype to pass -Wmissing-prototypes */
XS(XS_Apache__ScoreboardWorkerScore_conn_count)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Apache__ScoreboardWorkerScore	self;
	unsigned short	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Apache::ScoreboardWorkerScore")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Apache__ScoreboardWorkerScore,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Apache::ScoreboardWorkerScore::conn_count",
			"self", "Apache::ScoreboardWorkerScore");

	RETVAL = worker_score_conn_count(self);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Apache__ScoreboardWorkerScore_client); /* prototype to pass -Wmissing-prototypes */
XS(XS_Apache__ScoreboardWorkerScore_client)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Apache__ScoreboardWorkerScore	self;
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Apache::ScoreboardWorkerScore")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Apache__ScoreboardWorkerScore,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Apache::ScoreboardWorkerScore::client",
			"self", "Apache::ScoreboardWorkerScore");

	RETVAL = worker_score_client(self);
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Apache__ScoreboardWorkerScore_request); /* prototype to pass -Wmissing-prototypes */
XS(XS_Apache__ScoreboardWorkerScore_request)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Apache__ScoreboardWorkerScore	self;
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Apache::ScoreboardWorkerScore")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Apache__ScoreboardWorkerScore,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Apache::ScoreboardWorkerScore::request",
			"self", "Apache::ScoreboardWorkerScore");

	RETVAL = worker_score_request(self);
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Apache__ScoreboardWorkerScore_vhost); /* prototype to pass -Wmissing-prototypes */
XS(XS_Apache__ScoreboardWorkerScore_vhost)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Apache__ScoreboardWorkerScore	self;
	char *	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Apache::ScoreboardWorkerScore")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Apache__ScoreboardWorkerScore,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Apache::ScoreboardWorkerScore::vhost",
			"self", "Apache::ScoreboardWorkerScore");

	RETVAL = worker_score_vhost(self);
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Apache__ScoreboardWorkerScore_most_recent); /* prototype to pass -Wmissing-prototypes */
XS(XS_Apache__ScoreboardWorkerScore_most_recent)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Apache__ScoreboardWorkerScore	self;
	apr_uint32_t	RETVAL;
	dXSTARG;

	if (sv_derived_from(ST(0), "Apache::ScoreboardWorkerScore")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Apache__ScoreboardWorkerScore,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Apache::ScoreboardWorkerScore::most_recent",
			"self", "Apache::ScoreboardWorkerScore");

	RETVAL = worker_score_most_recent(self);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Apache__Scoreboard); /* prototype to pass -Wmissing-prototypes */
XS(boot_Apache__Scoreboard)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    XS_VERSION_BOOTCHECK ;

    {
        CV * cv ;

        (void)newXS("Apache::Scoreboard::send", XS_Apache__Scoreboard_send, file);
        (void)newXS("Apache::Scoreboard::freeze", XS_Apache__Scoreboard_freeze, file);
        (void)newXS("Apache::Scoreboard::thaw", XS_Apache__Scoreboard_thaw, file);
        (void)newXS("Apache::Scoreboard::image", XS_Apache__Scoreboard_image, file);
        (void)newXS("Apache::Scoreboard::server_limit", XS_Apache__Scoreboard_server_limit, file);
        (void)newXS("Apache::Scoreboard::thread_limit", XS_Apache__Scoreboard_thread_limit, file);
        (void)newXS("Apache::Scoreboard::parent_score", XS_Apache__Scoreboard_parent_score, file);
        (void)newXS("Apache::Scoreboard::worker_score", XS_Apache__Scoreboard_worker_score, file);
        (void)newXS("Apache::Scoreboard::pids", XS_Apache__Scoreboard_pids, file);
        (void)newXS("Apache::Scoreboard::parent_idx_by_pid", XS_Apache__Scoreboard_parent_idx_by_pid, file);
        (void)newXS("Apache::Scoreboard::thread_numbers", XS_Apache__Scoreboard_thread_numbers, file);
        (void)newXS("Apache::Scoreboard::up_time", XS_Apache__Scoreboard_up_time, file);
        (void)newXS("Apache::ScoreboardParentScore::next", XS_Apache__ScoreboardParentScore_next, file);
        (void)newXS("Apache::ScoreboardParentScore::worker_score", XS_Apache__ScoreboardParentScore_worker_score, file);
        (void)newXS("Apache::ScoreboardParentScore::next_worker_score", XS_Apache__ScoreboardParentScore_next_worker_score, file);
        (void)newXS("Apache::ScoreboardParentScore::next_live_worker_score", XS_Apache__ScoreboardParentScore_next_live_worker_score, file);
        (void)newXS("Apache::ScoreboardParentScore::next_active_worker_score", XS_Apache__ScoreboardParentScore_next_active_worker_score, file);
        (void)newXS("Apache::ScoreboardParentScore::pid", XS_Apache__ScoreboardParentScore_pid, file);
        (void)newXS("Apache::ScoreboardWorkerScore::times", XS_Apache__ScoreboardWorkerScore_times, file);
        cv = newXS("Apache::ScoreboardWorkerScore::stop_time", XS_Apache__ScoreboardWorkerScore_start_time, file);
        XSANY.any_i32 = 1 ;
        cv = newXS("Apache::ScoreboardWorkerScore::start_time", XS_Apache__ScoreboardWorkerScore_start_time, file);
        XSANY.any_i32 = 0 ;
        (void)newXS("Apache::ScoreboardWorkerScore::req_time", XS_Apache__ScoreboardWorkerScore_req_time, file);
        (void)newXS("Apache::ScoreboardWorkerScore::status", XS_Apache__ScoreboardWorkerScore_status, file);
        (void)newXS("Apache::ScoreboardWorkerScore::tid", XS_Apache__ScoreboardWorkerScore_tid, file);
        (void)newXS("Apache::ScoreboardWorkerScore::thread_num", XS_Apache__ScoreboardWorkerScore_thread_num, file);
        (void)newXS("Apache::ScoreboardWorkerScore::access_count", XS_Apache__ScoreboardWorkerScore_access_count, file);
        (void)newXS("Apache::ScoreboardWorkerScore::bytes_served", XS_Apache__ScoreboardWorkerScore_bytes_served, file);
        (void)newXS("Apache::ScoreboardWorkerScore::my_access_count", XS_Apache__ScoreboardWorkerScore_my_access_count, file);
        (void)newXS("Apache::ScoreboardWorkerScore::my_bytes_served", XS_Apache__ScoreboardWorkerScore_my_bytes_served, file);
        (void)newXS("Apache::ScoreboardWorkerScore::conn_bytes", XS_Apache__ScoreboardWorkerScore_conn_bytes, file);
        (void)newXS("Apache::ScoreboardWorkerScore::conn_count", XS_Apache__ScoreboardWorkerScore_conn_count, file);
        (void)newXS("Apache::ScoreboardWorkerScore::client", XS_Apache__ScoreboardWorkerScore_client, file);
        (void)newXS("Apache::ScoreboardWorkerScore::request", XS_Apache__ScoreboardWorkerScore_request, file);
        (void)newXS("Apache::ScoreboardWorkerScore::vhost", XS_Apache__ScoreboardWorkerScore_vhost, file);
        (void)newXS("Apache::ScoreboardWorkerScore::most_recent", XS_Apache__ScoreboardWorkerScore_most_recent, file);
    }

    /* Initialisation Section */

#line 201 "Scoreboard.xs"
{

    /* XXX: this must be performed only once and before other threads are spawned.
     * but not sure. could be that need to use local storage.
     *
     */
    status_flags_init();

    constants_init(aTHX);
}

#line 1789 "Scoreboard.c"

    /* End of Initialisation Section */

#if (PERL_REVISION == 5 && PERL_VERSION >= 9)
  if (PL_unitcheckav)
       call_list(PL_scopestack_ix, PL_unitcheckav);
#endif
    XSRETURN_YES;
}

